-- Export Lemmings level

function num_to_char ( number )
 return ( string.char ( math.mod ( number, 256 ) ) )
end

function WriteToFile ( file, number )
 file:write ( num_to_char( number ))
end

function main ()
 if mappy.msgBox ("Export Lemmings level", "This script will export the current layer to the Master System Lemmings format.\n\nDo you wish to continue?", mappy.MMB_OKCANCEL, mappy.MMB_ICONQUESTION) == mappy.MMB_OK then

  local w = mappy.getValue(mappy.MAPWIDTH)
  local h = mappy.getValue(mappy.MAPHEIGHT)

  
  if (not (w == 112) or not (h == 19)) then
   mappy.msgBox ("Export Lemmings level", "The map size needs to be 112 by 19 tiles.", mappy.MMB_OK, mappy.MMB_ICONINFO)
  else

   local isok,asname = mappy.fileRequester (".", "Master System Lemmings map (*.mlm)", "*.mlm", mappy.MMB_SAVE)
   if isok == mappy.MMB_OK then

    if (not (string.sub (string.lower (asname), -4) == ".mlm")) then
     asname = asname .. ".mlm"
    end

     adjust = tonumber (adjust)
-- open file as binary
     outas = io.open (asname, "wb")
     local zeroes = 0
     local y = 0
     while y < h do
      local x = 0
      while x < w do
       local mapval = mappy.getBlockValue (mappy.getBlock (x, y), mappy.BLKBG)
       if mapval == 0 then
        zeroes = zeroes + 1
        if zeroes == 255 then
         WriteToFile (outas, 0)
         WriteToFile (outas, 255)
         zeroes = 0
        end
       else
        if zeroes > 0 then
         WriteToFile (outas, 0)
         WriteToFile (outas, zeroes)
         zeroes = 0
        end
        WriteToFile (outas, mapval)
       end
       x = x + 1
      end
      y = y + 1
     end
     if zeroes > 0 then
      WriteToFile (outas, 0)
      WriteToFile (outas, zeroes)
      zeroes = 0
     end
     outas:close ()

   end
  end
 end
end

test, errormsg = pcall( main )
if not test then
    mappy.msgBox("Error ...", errormsg, mappy.MMB_OK, mappy.MMB_ICONEXCLAMATION)
end
