-- Import Lemmings level

function ReadFromFile ( file )
 local a = file:read (1)
 return (string.byte(a))
end

function main ()

  local w = mappy.getValue(mappy.MAPWIDTH)
  local tx = mappy.getValue(mappy.BLOCKWIDTH)
  local ty = mappy.getValue(mappy.BLOCKHEIGHT)

  
  if ((w == 0) or not (tx == 8) or not (ty == 8)) then
   mappy.msgBox ("Import Lemmings level", "You need to make a map with an 8x8 tilesize.", mappy.MMB_OK, mappy.MMB_ICONINFO)
  else

   local isok,asname = mappy.fileRequester (".", "Master System Lemmings map (*.mlm)", "*.mlm", mappy.MMB_OPEN)
   if isok == mappy.MMB_OK then

    if (not (string.sub (string.lower (asname), -4) == ".mlm")) then
     asname = asname .. ".mlm"
    end

-- open file as binary
     outas = io.open (asname, "rb")
     mappy.resizeMap(112,19,0)
     local x = 0
     local y = 0
     while y < 19 do
      local readbyte = ReadFromFile (outas)
      if readbyte == 0 then
       local ReadByteTwo = ReadFromFile (outas)
       for a=1, ReadByteTwo do
        if x == 112 then 
         x = 0
         y = y + 1
        end
        mappy.setBlock (x,y,0)
        x = x + 1
       end
      else
       mappy.setBlock (x,y,readbyte)
       x = x + 1
      end
      if x == 112 then
       x = 0
       y = y + 1
      end
     end
     outas:close ()

   end
  end
 end
mappy.updateScreen()

test, errormsg = pcall( main )
if not test then
    mappy.msgBox("Error ...", errormsg, mappy.MMB_OK, mappy.MMB_ICONEXCLAMATION)
end
