#ifndef TRAPS_H_INCLUDED
#define TRAPS_H_INCLUDED

int ImplementTrap(int trapType, int trapX, int trapY, int level, int rating)
{
    //Place the trap data in 3B1B
    int offset = 0x3B1B;
    romData[offset++] = (unsigned char) trapType;
    romData[offset++] = (unsigned char) trapX % 256;
    romData[offset++] = (unsigned char)(trapX >> 8);
    romData[offset] = (unsigned char) trapY;

    //Redirect the 3EC5 subroutine call to 7700
    //Asm instruction: call ($7700)
    offset =  0x3ec5;
    romData[offset++] = (unsigned char) 0xCD;
    romData[offset++] = (unsigned char) 0x00;
    romData[offset++] = (unsigned char) 0x77;

    /*Writing the trap subroutine at 7700.
    Asm instructions:
        xor a
        ld ($DB98), a
        ld ($DB97), a
        ld a, ($DB9E)
        cp (rating)
        jp nz, ($1F13)
        ld a, ($DB9D)
        ld l, $40 ;Loop back to 0 without triggering the 0 trap
        cp (level)
        jp z, ($1F9F)
        jp ($1F13)
    */

    offset = 0x7700;

    //xor a
    romData[offset++] = (unsigned char) 0xaf;

    //ld ($DB98), a
    romData[offset++] = (unsigned char) 0x32;
    romData[offset++] = (unsigned char) 0x98;
    romData[offset++] = (unsigned char) 0xdb;

    //ld ($DB97), a
    romData[offset++] = (unsigned char) 0x32;
    romData[offset++] = (unsigned char) 0x97;
    romData[offset++] = (unsigned char) 0xdb;

    //ld a, ($DB9E)
    romData[offset++] = (unsigned char) 0x3a;
    romData[offset++] = (unsigned char) 0x9e;
    romData[offset++] = (unsigned char) 0xdb;

    //cp (rating)
    romData[offset++] = (unsigned char) 0xfe;
    romData[offset++] = (unsigned char) rating;

    //jp nz, ($1F13)
    romData[offset++] = (unsigned char) 0xc2;
    romData[offset++] = (unsigned char) 0x13;
    romData[offset++] = (unsigned char) 0x1f;

    //ld a, ($DB9D)
    romData[offset++] = (unsigned char) 0x3a;
    romData[offset++] = (unsigned char) 0x9d;
    romData[offset++] = (unsigned char) 0xdb;

    //ld l, $40 (ld l, $00 if traps are disabled. This also fixes the bug where traps make holes in the level.)
    romData[offset++] = (unsigned char) 0x2e;
    if (trapType == 0) romData[offset++] = (unsigned char) 0x00; else romData[offset++] = (unsigned char) 0x40;

    //cp (level)
    romData[offset++] = (unsigned char) 0xfe;
    romData[offset++] = (unsigned char) level;

    //jp z, ($1F9F)
    romData[offset++] = (unsigned char) 0xca;
    romData[offset++] = (unsigned char) 0x9f;
    romData[offset++] = (unsigned char) 0x1f;

    //jp ($1F13)
    romData[offset++] = (unsigned char) 0xc3;
    romData[offset++] = (unsigned char) 0x13;
    romData[offset++] = (unsigned char) 0x1f;

    return 0;
}
#endif // TRAPS_H_INCLUDED
