#ifndef MAPPYMAP_H_INCLUDED
#define MAPPYMAP_H_INCLUDED

int MappyMap(char fileName[])
{
    FILE *fileStream;
    //Load the file for streaming
    fileStream = fopen(fileName, "rb");

    //Check if the file stream loaded
    if (fileStream == NULL)
    {
        cout << "File not found.";
        return -1;
    }

    //Move the file scan location forward 8 bytes. This is to ignore the values in the file that define the map size, which is unnecessary.
    if (fseek(fileStream, 8, SEEK_SET) != 0)
    {
        cout << "Seek set failed.";
        return -1;
    }

     //Declare file-reading variables
     int zeroes = 0, readByte, arrayIndex = 0;

     //This is where the scanning of the file begins
     while (readByte != EOF)
    {
        readByte = fgetc(fileStream);

        //The 0 branch is necessary because the format used in the game attempts to compress the data
        //by using a second byte after 0x00 to determine consecutive blank tiles.
        switch (readByte)
        {
            case 0:
            {
                zeroes++;

                //A 256th consecutive 0x00 byte would spoil the compressed data.
                if (zeroes == 255)
                {
                    mapFormat[arrayIndex] = 0;
                    mapFormat[arrayIndex + 1] = zeroes;
                    zeroes = 0;
                    arrayIndex += 2;
                }
                break;
            }

            case EOF:
            {
                if (zeroes != 0)
                {
                    mapFormat[arrayIndex] = 0;
                    mapFormat[arrayIndex + 1] = zeroes;
                    zeroes = 0;
                    arrayIndex += 2;
                }

                //cout << "EOF reached!\n";
                break;
            }

            default:
            {
                if (zeroes != 0)
                {
                    mapFormat[arrayIndex] = 0;
                    mapFormat[arrayIndex + 1] = zeroes;
                    zeroes = 0;
                    arrayIndex += 2;
                }

                mapFormat[arrayIndex] = readByte;
                arrayIndex++;
            }
        }
        //The Mappy binary file stores tile data as 32-bit integers in little endian form, so skip the next 3 bytes.
        fseek(fileStream, 3, SEEK_CUR);
    }
    //Close the file
    fclose (fileStream);

    //Display the stored data
    /*for (int j=0; j<arrayIndex; j++)
    {
        cout << hex << (int)mapFormat[j] << dec << " ";
    }*/

    return arrayIndex;
}

#endif // MAPPYMAP_H_INCLUDED
